Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# TAO_Unbounded_Array_Sequence Class Template Reference

Parametric sequence for arrays. More...

`#include <Sequence_T.h>`

Inheritance diagram for TAO_Unbounded_Array_Sequence

[legend]
Collaboration diagram for TAO_Unbounded_Array_Sequence:

[legend]
List of all members.

## Public Methods
| TAO_Unbounded_Array_Sequence (void)
| default ctor.
| TAO_Unbounded_Array_Sequence (CORBA::ULong max)
| Constructor with a "hint" for the maximum capacity.
| TAO_Unbounded_Array_Sequence (CORBA::ULong maximum, CORBA::ULong length, T *data, CORBA::Boolean release=0)
| Constructor with a given buffer.
| TAO_Unbounded_Array_Sequence (const TAO_Unbounded_Array_Sequence<T, T_var> &)
| Copy ctor, deep copies.
| ~TAO_Unbounded_Array_Sequence (void)
| dtor releases all the contained elements.
TAO_Unbounded_Array_Sequence< T, T_var>& | operator= ( const TAO_Unbounded_Array_Sequence <T, T_var> & )
T& | operator[] (CORBA::ULong)
| operator [].
const T& | operator[] (CORBA::ULong) const
| operator [].
virtual void | _allocate_buffer (CORBA::ULong length)
| allocate a buffer of the requested length. The buffer is allocated for the right type.
virtual void | _deallocate_buffer (void)
| deallocate the buffer.
T* | get_buffer (CORBA::Boolean orphan = 0)
const T* | get_buffer (void) const
void | replace (CORBA::ULong max, CORBA::ULong length, T *data, CORBA::Boolean release = 0)
## Static Public Methods
T* | allocbuf (CORBA::ULong)
| The allocbuf function allocates a vector of T elements that can be passed to the T *data constructor.
void | freebuf (T *)
| Release all the elements.

## Detailed Description

### template<class T, class T_var> template class TAO_Unbounded_Array_Sequence

Parametric sequence for arrays.

The IDL mapping for arrays includes some unique allocation, deallocation, and copying functions, and precludes direct assignment of one array to another. Also, the Any and CDR operators use a special class derived from the array. For these reasons, we use a special class for sequences of arrays, parametrized on the array element type.

## Constructor & Destructor Documentation

template<classT, classT_var>
ACE_INLINE TAO_Unbounded_Array_Sequence< T,T_var >::TAO_Unbounded_Array_Sequence<T, T_var> ( | void )

| default ctor.

template<classT, classT_var>
ACE_INLINE TAO_Unbounded_Array_Sequence< T,T_var >::TAO_Unbounded_Array_Sequence<T, T_var> ( | CORBA::ULong maximum )

| Constructor with a "hint" for the maximum capacity.

template<classT, classT_var>
ACE_INLINE TAO_Unbounded_Array_Sequence< T,T_var >::TAO_Unbounded_Array_Sequence<T, T_var> ( | CORBA::ULong maximum,
| CORBA::ULong length,
| T * value,
| CORBA::Boolean release = 0 )

| Constructor with a given buffer.

template<classT, classT_var>
TAO_Unbounded_Array_Sequence<T, T_var>::TAO_Unbounded_Array_Sequence<T, T_var> ( | const TAO_Unbounded_Array_Sequence< T,T_var >& rhs )

| Copy ctor, deep copies.

template<classT, classT_var>
TAO_Unbounded_Array_Sequence<T, T_var>::~TAO_Unbounded_Array_Sequence<T, T_var> ( | void )

| dtor releases all the contained elements.

## Member Function Documentation

template<classT, classT_var>
void TAO_Unbounded_Array_Sequence<T, T_var>::_allocate_buffer ( | CORBA::ULong length )`[virtual]`

| allocate a buffer of the requested length. The buffer is allocated for the right type. Reimplemented from TAO_Base_Sequence.

template<classT, classT_var>
void TAO_Unbounded_Array_Sequence<T, T_var>::_deallocate_buffer ( | void )`[virtual]`

| deallocate the buffer. Reimplemented from TAO_Base_Sequence.

template<classT, classT_var>
T * TAO_Unbounded_Array_Sequence<T, T_var>::allocbuf ( | CORBA::ULong nelems )`[static]`

| The allocbuf function allocates a vector of T elements that can be passed to the T *data constructor.

template<classT, classT_var>
ACE_INLINE void TAO_Unbounded_Array_Sequence< T,T_var >::freebuf ( | T * buffer )`[static]`

| Release all the elements.

template<classT, classT_var>
ACE_INLINE const T * TAO_Unbounded_Array_Sequence< T,T_var >::get_buffer ( | void ) const

| This function allows read-only access to the sequence buffer. The sequence returns its buffer, allocating one of one has not yet been allocated. No direct modification of the returned buffer by the caller is permitted.

template<classT, classT_var>
ACE_INLINE T * TAO_Unbounded_Array_Sequence< T,T_var >::get_buffer ( | CORBA::Boolean orphan = 0 )

| Allows read-write access to the underlying buffer. If <orphan> is FALSE the sequence returns a pointer to its buffer, allocating one if it has not yet done so. The number of elements in the buffer can be determined from the sequence <length> accessor. If the <orphan> argument to <get_buffer> is FALSE, the sequence maintains ownership of the underlying buffer. Elements in the returned buffer may be directly replaced by the caller. If the <orphan> argument to <get_buffer> is TRUE, the sequence yields ownership of the buffer to the caller. If <orphan> is TRUE and the sequence does not own its buffer (i.e., its <release> flag is FALSE), the return value is a null pointer. If the buffer is taken from the sequence using this form of <get_buffer>, the sequence reverts to the same state it would have if constructed using its default constructor. The caller becomes responsible for eventually freeing each element of the returned buffer (for strings, wide string, and object references), and then freeing the returned buffer itself using <freebuf>.

template<classT, classT_var>
TAO_Unbounded_Array_Sequence< T,T_var >& TAO_Unbounded_Array_Sequence<T, T_var>::operator= ( | const TAO_Unbounded_Array_Sequence< T,T_var >& rhs )

| The assignment operator first releases all object reference members and frees all string members, and then performs a deepcopy to create a new structure.

template<classT, classT_var>
ACE_INLINE const T & TAO_Unbounded_Array_Sequence< T,T_var >::operator[] ( | CORBA::ULong i ) const

| operator [].

template<classT, classT_var>
ACE_INLINE T & TAO_Unbounded_Array_Sequence< T,T_var >::operator[] ( | CORBA::ULong i )

| operator [].

template<classT, classT_var>
ACE_INLINE void TAO_Unbounded_Array_Sequence< T,T_var >::replace ( | CORBA::ULong max,
| CORBA::ULong length,
| T * data,
| CORBA::Boolean release = 0 )

| Allows the buffer underlying a sequence to be replaced. The parameters to <replace> are identical in type, order, and purpose to those for the <T *data> constructor for the sequence.

The documentation for this class was generated from the following files:

- Sequence_T.h
- Sequence_T.cpp
- Sequence_T.i